//------------------------------------------------------------------------------
// <copyright file="CSSqlFunction.cs" company="Microsoft">
//     Copyright (c) Microsoft Corporation.  All rights reserved.
// </copyright>
//------------------------------------------------------------------------------
using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;

public partial class UserDefinedFunctions
{
    [Microsoft.SqlServer.Server.SqlFunction(DataAccess = DataAccessKind.Read)]
    public static SqlMoney GetOrderTotalCLR(SqlInt32 orderId)
    {
        using (SqlConnection conn = new SqlConnection("context connection=true"))
        {
            conn.Open();
            SqlCommand cmd = new SqlCommand(
      @"select @Result = sum(Quantity * Price)  
    from dbo.OrderLineItems 
    where OrderId = @OrderId", conn);

            cmd.Parameters.Add("@OrderId", SqlDbType.Int).Value = orderId;
            cmd.Parameters.Add("@Result", SqlDbType.Float).Direction = ParameterDirection.Output;
            cmd.ExecuteNonQuery();
            return new SqlMoney((double)cmd.Parameters[1].Value);
        }
    }

}
